scala.collection.immutable

# Stream

###
Related Docs: object Stream | package immutable

#### abstract class Stream[+A] extends AbstractSeq[A] with LinearSeq[A] with GenericTraversableTemplate[A, Stream] with LinearSeqOptimized[A, Stream[A]] with Serializable

The class `Stream` implements lazy lists where elements are only evaluated when they are needed. Here is an example:

    import scala.math.BigInt
    object Main extends App {

      val fibs: Stream[BigInt] = BigInt(0) #:: BigInt(1) #:: fibs.zip(fibs.tail).map { n => n._1 + n._2 }

      fibs take 5 foreach println
    }

    // prints
    //
    // 0
    // 1
    // 1
    // 2
    // 3

The `Stream` class also employs memoization such that previously computed values are converted from `Stream` elements to concrete values of type `A`. To illustrate, we will alter body of the `fibs` value above and take some more values:

    import scala.math.BigInt
    object Main extends App {

      val fibs: Stream[BigInt] = BigInt(0) #:: BigInt(1) #:: fibs.zip(
        fibs.tail).map(n => {
          println("Adding %d and %d".format(n._1, n._2))
          n._1 + n._2
        })

      fibs take 5 foreach println
      fibs take 6 foreach println
    }

    // prints
    //
    // 0
    // 1
    // Adding 0 and 1
    // 1
    // Adding 1 and 1
    // 2
    // Adding 1 and 2
    // 3

    // And then prints
    //
    // 0
    // 1
    // 1
    // 2
    // 3
    // Adding 2 and 3
    // 5

There are a number of subtle points to the above example.

- The definition of `fibs` is a `val` not a method. The memoization of the `Stream` requires us to have somewhere to store the information and a `val` allows us to do that.
- While the `Stream` is actually being modified during access, this does not change the notion of its immutability. Once the values are memoized they do not change and values that have yet to be memoized still "exist", they simply haven't been realized yet.
- One must be cautious of memoization; you can very quickly eat up large amounts of memory if you're not careful. The reason for this is that the memoization of the `Stream` creates a structure much like scala.collection.immutable.List. So long as something is holding on to the head, the head holds on to the tail, and so it continues recursively. If, on the other hand, there is nothing holding on to the head (e.g. we used `def` to define the `Stream`) then once it is no longer being used directly, it disappears.
- Note that some operations, including drop, dropWhile, flatMap or collect may process a large number of intermediate elements before returning. These necessarily hold onto the head, since they are methods on `Stream`, and a stream holds its own head. For computations of this sort where memoization is not desired, use `Iterator` when possible.

    // For example, let's build the natural numbers and do some silly iteration
    // over them.

    // We'll start with a silly iteration
    def loop(s: String, i: Int, iter: Iterator[Int]): Unit = {
      // Stop after 200,000
      if (i < 200001) {
        if (i % 50000 == 0) println(s + i)
        loop(s, iter.next, iter)
      }
    }

    // Our first Stream definition will be a val definition
    val stream1: Stream[Int] = {
      def loop(v: Int): Stream[Int] = v #:: loop(v + 1)
      loop(0)
    }

    // Because stream1 is a val, everything that the iterator produces is held
    // by virtue of the fact that the head of the Stream is held in stream1
    val it1 = stream1.iterator
    loop("Iterator1: ", it1.next, it1)

    // We can redefine this Stream such that all we have is the Iterator left
    // and allow the Stream to be garbage collected as required.  Using a def
    // to provide the Stream ensures that no val is holding onto the head as
    // is the case with stream1
    def stream2: Stream[Int] = {
      def loop(v: Int): Stream[Int] = v #:: loop(v + 1)
      loop(0)
    }
    val it2 = stream2.iterator
    loop("Iterator2: ", it2.next, it2)

    // And, of course, we don't actually need a Stream at all for such a simple
    // problem.  There's no reason to use a Stream if you don't actually need
    // one.
    val it3 = new Iterator[Int] {
      var i = -1
      def hasNext = true
      def next(): Int = { i += 1; i }
    }
    loop("Iterator3: ", it3.next, it3)

- The fact that `tail` works at all is of interest. In the definition of `fibs` we have an initial `(0, 1, Stream(...))` so `tail` is deterministic. If we deinfed `fibs` such that only `0` were concretely known then the act of determining `tail` would require the evaluation of `tail` which would cause an infinite recursion and stack overflow. If we define a definition where the tail is not initially computable then we're going to have an infinite recursion:

    // The first time we try to access the tail we're going to need more
    // information which will require us to recurse, which will require us to
    // recurse, which...
    val sov: Stream[Vector[Int]] = Vector(0) #:: sov.zip(sov.tail).map { n => n._1 ++ n._2 }

The definition of `fibs` above creates a larger number of objects than necessary depending on how you might want to implement it. The following implementation provides a more "cost effective" implementation due to the fact that it has a more direct route to the numbers themselves:

    lazy val fib: Stream[Int] = {
      def loop(h: Int, n: Int): Stream[Int] = h #:: loop(n, h + n)
      loop(1, 1)
    }

Note that `mkString` forces evaluation of a `Stream`, but `addString` does not. In both cases, a `Stream` that is or ends in a cycle (e.g. `lazy val s: Stream[Int] = 0 #:: s`) will convert additional trips through the cycle to `...`. Additionally, `addString` will display an un-memoized tail as `?`.

A

  the type of the elements contained in this stream.

Self Type
  Stream[A]
Annotations
  @deprecatedInheritance( "This class will be sealed." , "2.11.0" )
Source
  Stream.scala
Version

  1.1 08/08/03

Since

  2.8

See also

  "Scala's Collection Library overview" section on `Streams` for more information.

Linear Supertypes
Serializable, java.io.Serializable, LinearSeqOptimized[A, Stream[A]], LinearSeq[A], collection.LinearSeq[A], LinearSeqLike[A, Stream[A]], Seq[A], Iterable[A], Traversable[A], Immutable, AbstractSeq[A], collection.Seq[A], SeqLike[A, Stream[A]], GenSeq[A], GenSeqLike[A, Stream[A]], PartialFunction[Int, A], (Int) ⇒ A, AbstractIterable[A], collection.Iterable[A], IterableLike[A, Stream[A]], Equals, GenIterable[A], GenIterableLike[A, Stream[A]], AbstractTraversable[A], collection.Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, Stream], TraversableLike[A, Stream[A]], GenTraversableLike[A, Stream[A]], Parallelizable[A, ParSeq[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, Stream[A]], HasNewBuilder[A, scala.collection.immutable.Stream[A] @scala.annotation.unchecked.uncheckedVariance], AnyRef, Any
Known Subclasses
Cons, Empty
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Stream
2. Serializable
3. Serializable
4. LinearSeqOptimized
5. LinearSeq
6. LinearSeq
7. LinearSeqLike
8. Seq
9. Iterable
10. Traversable
11. Immutable
12. AbstractSeq
13. Seq
14. SeqLike
15. GenSeq
16. GenSeqLike
17. PartialFunction
18. Function1
19. AbstractIterable
20. Iterable
21. IterableLike
22. Equals
23. GenIterable
24. GenIterableLike
25. AbstractTraversable
26. Traversable
27. GenTraversable
28. GenericTraversableTemplate
29. TraversableLike
30. GenTraversableLike
31. Parallelizable
32. TraversableOnce
33. GenTraversableOnce
34. FilterMonadic
35. HasNewBuilder
36. AnyRef
37. Any

Implicitly

1. by CollectionsHaveToParArray
2. by MonadOps
3. by any2stringadd
4. by StringFormat
5. by Ensuring
6. by ArrowAssoc
7. by alternateImplicit

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Stream()

### Type Members

1. #### type Self = Stream[A]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected[this]
   Definition Classes
     TraversableLike

2. #### final class StreamWithFilter extends WithFilter

   A lazier implementation of WithFilter than TraversableLike's.

3. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

   A class supporting filtered operations. Instances of this class are returned by method `withFilter`.

   Definition Classes
     TraversableLike

### Abstract Value Members

1. #### abstract def tailDefined: Boolean

   Is the tail of this stream defined?

   Is the tail of this stream defined?

   Attributes
     protected

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Stream[A] to any2stringadd[Stream[A]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[Stream[A], B, That]): That

   Create a new stream which contains all elements of this stream followed by all elements of Traversable `that`.

   Create a new stream which contains all elements of this stream followed by all elements of Traversable `that`.

   B

     The element type of the returned collection.That

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     The scala.collection.GenTraversableOnce the be contatenated to this `Stream`.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     A new collection containing the result of concatenating `this` with `that`.

   Definition Classes
     Stream → TraversableLike → GenTraversableLike
   Note

     This method doesn't cause the `Stream` to be fully realized but it should be noted that using the `++` operator from another collection type could cause infinite realization of a `Stream`. For example, referring to the definition of `fibs` in the preamble, the following would never return: `List(BigInt(12)) ++ fibs`.

     ,

     It's subtle why this works. We know that if the target type of the scala.collection.mutable.Builder `That` is either a `Stream`, or one of its supertypes, or undefined, then `StreamBuilder` will be chosen for the implicit. We recognize that fact and optimize to get more laziness.

5. #### def ++:[B >: A, That](that: collection.Traversable[B])(implicit bf: CanBuildFrom[Stream[A], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this traversable collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

6. #### def ++:[B](that: TraversableOnce[B]): Stream[B]

   [use case] As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   [use case]

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new stream which contains all elements of this stream followed by all elements of `that`.

   Definition Classes
     TraversableLike
   Full Signature

   #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[Stream[A], B, That]): That

7. #### def +:(elem: A): Stream[A]

   [use case] A copy of the stream with an element prepended.

   [use case]

   A copy of the stream with an element prepended.

   Note that :-ending operators are right associative (see example). A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

   Also, the original stream is not modified, so you will want to capture the result.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = 2 +: x
       y: List[Int] = List(2, 1)

       scala> println(x)
       List(1)

   elem

     the prepended element

   returns

     a new stream consisting of `elem` followed by all elements of this stream.

   Definition Classes
     Stream → SeqLike → GenSeqLike
   Full Signature

   #### def +:[B >: A, That](elem: B)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

8. #### def ->[B](y: B): (Stream[A], B)

   Implicit information
     This member is added by an implicit conversion from Stream[A] to ArrowAssoc[Stream[A]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

9. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this traversable or iterator.

   Definition Classes
     TraversableOnce → GenTraversableOnce

10. #### def :+(elem: A): Stream[A]

    [use case] A copy of this stream with an element appended.

    [use case]

    A copy of this stream with an element appended.

    A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

    Note: will not terminate for infinite-sized collections.

    Example:

        scala> val a = List(1)
        a: List[Int] = List(1)

        scala> val b = a :+ 2
        b: List[Int] = List(1, 2)

        scala> println(a)
        List(1)

    elem

      the appended element

    returns

      a new stream consisting of all elements of this stream followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def :+[B >: A, That](elem: B)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

11. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = (a :\ 5)(_+_)
        b: Int = 15

        scala> val c = (a :\ 5)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

12. #### final def ==(arg0: Any): Boolean

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    arg0

      the object to compare against this object for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

13. #### def addString(b: mutable.StringBuilder, start: String, sep: String, end: String): mutable.StringBuilder

    Write all defined elements of this iterable into given string builder.

    Write all defined elements of this iterable into given string builder. The written text begins with the string `start` and is finished by the string `end`. Inside, the string representations of defined elements (w.r.t. the method `toString()`) are separated by the string `sep`. The method will not force evaluation of undefined elements. A tail of such elements will be represented by a `"?"` instead. A cyclic stream is represented by a `"..."` at the point where the cycle repeats.

    b

      The collection.mutable.StringBuilder factory to which we need to add the string elements.

    start

      The prefix of the resulting string (e.g. "Stream(")

    sep

      The separator between elements of the resulting string (e.g. ",")

    end

      The end of the resulting string (e.g. ")")

    returns

      The original collection.mutable.StringBuilder containing the resulting string.

    Definition Classes
      Stream → TraversableOnce

14. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this traversable or iterator to a string builder.

    Appends all elements of this traversable or iterator to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator without any separator string.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        h: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

15. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this traversable or iterator to a string builder using a separator string.

    Appends all elements of this traversable or iterator to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator, separated by the string `sep`.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

16. #### def aggregate[B](z: ⇒ B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

        pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

17. #### def andThen[C](k: (A) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

18. #### def append[B >: A](rest: ⇒ TraversableOnce[B]): Stream[B]

    The stream resulting from the concatenation of this stream with the argument stream.

    The stream resulting from the concatenation of this stream with the argument stream.

    rest

      The stream that gets appended to this stream

    returns

      The stream containing elements of this stream and the traversable object.

19. #### def apply(n: Int): A

    Selects an element by its index in the sequence.

    Selects an element by its index in the sequence. Note: the execution of `apply` may take time proportional to the index value.

    returns

      the element of this sequence at index `idx`, where `0` indicates the first element.

    Definition Classes
      LinearSeqOptimized → SeqLike → GenSeqLike
    Exceptions thrown

      `IndexOutOfBoundsException` if `idx` does not satisfy `0 <= idx < length`.

20. #### def applyOrElse[A1 <: Int, B1 >: A](x: A1, default: (A1) ⇒ B1): B1

    Applies this partial function to the given argument when it is contained in the function domain.

    Applies this partial function to the given argument when it is contained in the function domain. Applies fallback function where this partial function is not defined.

    Note that expression `pf.applyOrElse(x, default)` is equivalent to

        if(pf isDefinedAt x) pf(x) else default(x)

    except that `applyOrElse` method can be implemented more efficiently. For all partial function literals the compiler generates an `applyOrElse` implementation which avoids double evaluation of pattern matchers and guards. This makes `applyOrElse` the basis for the efficient implementation for many operations and scenarios, such as:

    - combining partial functions into `orElse`/`andThen` chains does not lead to excessive `apply`/`isDefinedAt` evaluation
    - `lift` and `unlift` do not evaluate source functions twice on each invocation
    - `runWith` allows efficient imperative-style combining of partial functions with conditionally applied actions

    For non-literal partial function classes with nontrivial `isDefinedAt` method it is recommended to override `applyOrElse` with custom implementation that avoids double `isDefinedAt` evaluation. This may result in better performance and more predictable behavior w.r.t. side effects.

    x

      the function argument

    default

      the fallback function

    returns

      the result of this function or fallback function application.

    Definition Classes
      PartialFunction
    Since

      2.10

21. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

22. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this iterable collection should be compared

    returns

      `true`, if this iterable collection can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

23. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

24. #### final def collect[B](pf: PartialFunction[A, B]): Stream[B]

    [use case] Builds a new collection by applying a partial function to all elements of this stream on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this stream on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the stream.

    returns

      a new stream resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      Stream → TraversableLike → GenTraversableLike
    Full Signature

    #### final def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[Stream[A], B, That]): That

25. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

26. #### def combinations(n: Int): Iterator[Stream[A]]

    Iterates over combinations.

    Iterates over combinations. A _combination_ of length `n` is a subsequence of the original sequence, with the elements taken in order. Thus, `"xy"` and `"yy"` are both length-2 combinations of `"xyy"`, but `"yx"` is not. If there is more than one way to generate the same subsequence, only one will be returned.

    For example, `"xyyy"` has three different ways to generate `"xy"` depending on whether the first, second, or third `"y"` is selected. However, since all are identical, only one will be chosen. Which of the three will be taken is an implementation detail that is not defined.

    returns

      An Iterator which traverses the possible n-element combinations of this sequence.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

27. #### def companion: GenericCompanion[Stream]

    The factory companion object that builds instances of class `Stream`.

    The factory companion object that builds instances of class `Stream`. (or its `Iterable` superclass where class `Stream` is not a `Seq`.)

    Definition Classes
      Stream → LinearSeq → LinearSeq → Seq → Iterable → Traversable → Seq → GenSeq → Iterable → GenIterable → Traversable → GenTraversable → GenericTraversableTemplate

28. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ A

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1
    Annotations
      @unspecialized()

29. #### def contains[A1 >: A](elem: A1): Boolean

    Tests whether this sequence contains a given value as an element.

    Tests whether this sequence contains a given value as an element.

    Note: may not terminate for infinite-sized collections.

    elem

      the element to test.

    returns

      `true` if this sequence has an element that is equal (as determined by `==`) to `elem`, `false` otherwise.

    Definition Classes
      LinearSeqOptimized → SeqLike

30. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this sequence contains a given sequence as a slice.

    Tests whether this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      `true` if this sequence contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

31. #### def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this stream to an array.

    [use case]

    Copies elements of this stream to an array. Fills the given array `xs` with at most `len` elements of this stream, starting at position `start`. Copying will stop once either the end of the current stream is reached, or the end of the array is reached, or `len` elements have been copied.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

32. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this stream to an array.

    [use case]

    Copies values of this stream to an array. Fills the given array `xs` with values of this stream. Copying will stop once either the end of the current stream is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B]): Unit

33. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this stream to an array.

    [use case]

    Copies values of this stream to an array. Fills the given array `xs` with values of this stream, beginning at index `start`. Copying will stop once either the end of the current stream is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

34. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this traversable or iterator to a buffer.

    Copies all elements of this traversable or iterator to a buffer.

    Note: will not terminate for infinite-sized collections.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

35. #### final def corresponds[B](that: GenSeq[B])(p: (A, B) ⇒ Boolean): Boolean

    Tests whether every element of this sequence relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this sequence relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this sequence and `y` of `that`, otherwise `false`.

    Definition Classes
      LinearSeqLike → SeqLike → GenSeqLike
    Annotations
      @tailrec()

36. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

37. #### def diff(that: collection.Seq[A]): Stream[A]

    [use case] Computes the multiset difference between this stream and another sequence.

    [use case]

    Computes the multiset difference between this stream and another sequence.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence of elements to remove

    returns

      a new stream which contains all elements of this stream except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def diff[B >: A](that: GenSeq[B]): Stream[A]

38. #### def distinct: Stream[A]

    Builds a new stream from this stream in which any duplicates (as determined by `==`) have been removed.

    Builds a new stream from this stream in which any duplicates (as determined by `==`) have been removed. Among duplicate elements, only the first one is retained in the resulting `Stream`.

    returns

      A new `Stream` representing the result of applying distinctness to the original `Stream`.

    Definition Classes
      Stream → SeqLike → GenSeqLike
    Example:

    1.     // Creates a Stream where every element is duplicated
           def naturalsFrom(i: Int): Stream[Int] = i #:: { i #:: naturalsFrom(i + 1) }
           naturalsFrom(1) take 6 mkString ", "
           // produces: "1, 1, 2, 2, 3, 3"
           (naturalsFrom(1) distinct) take 6 mkString ", "
           // produces: "1, 2, 3, 4, 5, 6"

39. #### final def drop(n: Int): Stream[A]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this stream.

    returns

      a stream consisting of all elements of this stream except the first `n` ones, or else the empty stream, if this stream has less than `n` elements.

    Definition Classes
      Stream → LinearSeqOptimized → IterableLike → TraversableLike → GenTraversableLike
    Annotations
      @tailrec()

40. #### def dropRight(n: Int): Stream[A]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    Note: lazily evaluated; will terminate for infinite-sized collections.

    n

      The number of elements to take

    returns

      a stream consisting of all elements of this stream except the last `n` ones, or else the empty stream, if this stream has less than `n` elements.

    Definition Classes
      Stream → LinearSeqOptimized → IterableLike

41. #### def dropWhile(p: (A) ⇒ Boolean): Stream[A]

    Returns the a `Stream` representing the longest suffix of this iterable whose first element does not satisfy the predicate `p`.

    Returns the a `Stream` representing the longest suffix of this iterable whose first element does not satisfy the predicate `p`.

    p

      the test predicate.

    returns

      A new `Stream` representing the results of applying `p` to the original `Stream`.

    Definition Classes
      Stream → TraversableLike → GenTraversableLike
    Example:

    1.     // Assume we have a Stream that takes the first 20 natural numbers
           def naturalsLt50(i: Int): Stream[Int] = i #:: { if (i < 20) naturalsLt50(i * + 1) else Stream.Empty }
           naturalsLt50(0) dropWhile { _ < 10 }
           // produces: "10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20"

    Note

      This method realizes the entire `Stream` beyond the truth value of the predicate `p`.

42. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this sequence ends with the given sequence.

    Tests whether this sequence ends with the given sequence.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      `true` if this sequence has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqLike → GenSeqLike

43. #### def ensuring(cond: (Stream[A]) ⇒ Boolean, msg: ⇒ Any): Stream[A]

    Implicit information
      This member is added by an implicit conversion from Stream[A] to Ensuring[Stream[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

44. #### def ensuring(cond: (Stream[A]) ⇒ Boolean): Stream[A]

    Implicit information
      This member is added by an implicit conversion from Stream[A] to Ensuring[Stream[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

45. #### def ensuring(cond: Boolean, msg: ⇒ Any): Stream[A]

    Implicit information
      This member is added by an implicit conversion from Stream[A] to Ensuring[Stream[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

46. #### def ensuring(cond: Boolean): Stream[A]

    Implicit information
      This member is added by an implicit conversion from Stream[A] to Ensuring[Stream[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

47. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

48. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → Any

49. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this sequence.

    Tests whether a predicate holds for some of the elements of this sequence.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `false` if this sequence is empty, otherwise `true` if the given predicate `p` holds for some of the elements of this sequence, otherwise `false`

    Definition Classes
      LinearSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

50. #### def filter(p: (A) ⇒ Boolean): Stream[A]

    Returns all the elements of this `Stream` that satisfy the predicate `p` in a new `Stream` - i.e., it is still a lazy data structure.

    Returns all the elements of this `Stream` that satisfy the predicate `p` in a new `Stream` - i.e., it is still a lazy data structure. The order of the elements is preserved

    p

      the predicate used to filter the stream.

    returns

      the elements of this stream satisfying `p`.

    Definition Classes
      Stream → TraversableLike → GenTraversableLike
    Example:

    1.     def naturalsFrom(i: Int): Stream[Int] = i #:: naturalsFrom(i + 1)
           naturalsFrom(1)  10 } filter { _ % 5 == 0 } take 10 mkString(", ")
           // produces

51. #### def filterNot(p: (A) ⇒ Boolean): Stream[A]

    Selects all elements of this traversable collection which do not satisfy a predicate.

    Selects all elements of this traversable collection which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new traversable collection consisting of all elements of this traversable collection that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

52. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

53. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the sequence satisfying a predicate, if any.

    Finds the first element of the sequence satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the sequence that satisfies `p`, or `None` if none exists.

    Definition Classes
      LinearSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

54. #### final def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[Stream[A], B, That]): That

    Applies the given function `f` to each element of this stream, then concatenates the results.

    Applies the given function `f` to each element of this stream, then concatenates the results. As with `map` this function does not need to realize the entire `Stream` but continues to keep it as a lazy `Stream`.

    B

      The element type of the returned collection That.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply on each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      `f(a0) ::: ... ::: f(an)` if this stream is `[a0, ..., an]`.

    Definition Classes
      Stream → TraversableLike → GenTraversableLike → FilterMonadic
    Example:

    1.     // Let's create a Stream of Vectors, each of which contains the
           // collection of Fibonacci numbers up to the current value.  We
           // can then 'flatMap' that Stream.

           val fibVec: Stream[Vector[Int]] = Vector(0) #:: Vector(0, 1) #:: fibVec.zip(fibVec.tail).map(n => {
             n._2 ++ Vector(n._1.last + n._2.last)
           })

           fibVec take 5 foreach println
           // prints
           // Vector(0)
           // Vector(0, 1)
           // Vector(0, 1, 1)
           // Vector(0, 1, 1, 2)
           // Vector(0, 1, 1, 2, 3)

           // If we now want to `flatMap` across that stream by adding 10
           // we can see what the series turns into:

           fibVec.flatMap(_.map(_ + 10)) take 15 mkString(", ")
           // produces: 10, 10, 11, 10, 11, 11, 10, 11, 11, 12, 10, 11, 11, 12, 13

       Note: Currently `flatMap` will evaluate as much of the Stream as needed until it finds a non-empty element for the head, which is non-lazy.

55. #### def flatten[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): Stream[B]

    Evaluates and concatenates all elements within the `Stream` into a new flattened `Stream`.

    Evaluates and concatenates all elements within the `Stream` into a new flattened `Stream`.

    B

      The type of the elements of the resulting `Stream`.

    asTraversable

      an implicit conversion which asserts that the element type of this stream is a `GenTraversable`.

    returns

      A new `Stream` of type `B` of the flattened elements of `this` `Stream`.

    Definition Classes
      Stream → GenericTraversableTemplate
    Example:

    1.     val sov: Stream[Vector[Int]] = Vector(0) #:: Vector(0, 0) #:: sov.zip(sov.tail).map { n => n._1 ++ n._2 }
           sov.flatten take 10 mkString ", "
           // produces: "0, 0, 0, 0, 0, 0, 0, 0, 0, 0"

56. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

57. #### final def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Stream specialization of foldLeft which allows GC to collect along the way.

    Stream specialization of foldLeft which allows GC to collect along the way.

    B

      The type of value being accumulated.

    z

      The initial value seeded into the function `op`.

    op

      The operation to perform on successive elements of the `Stream`.

    returns

      The accumulated value from successive applications of `op`.

    Definition Classes
      Stream → LinearSeqOptimized → TraversableOnce → GenTraversableOnce
    Annotations
      @tailrec()

58. #### def foldRight[B](z: B)(f: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this sequence and a start value, going right to left.

    Applies a binary operator to all elements of this sequence and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    B

      the result type of the binary operator.

    z

      the start value.

    returns

      the result of inserting `op` between consecutive elements of this sequence, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this sequence.

    Definition Classes
      LinearSeqOptimized → IterableLike → TraversableOnce → GenTraversableOnce

59. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this sequence.

    Tests whether a predicate holds for all elements of this sequence.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if this sequence is empty, otherwise `true` if the given predicate `p` holds for all elements of this sequence, otherwise `false`.

    Definition Classes
      LinearSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

60. #### def force: Stream[A]

    Forces evaluation of the whole stream and returns it.

    Forces evaluation of the whole stream and returns it.

    returns

      The fully realized `Stream`.

    Note

      Often we use `Stream`s to represent an infinite set or series. If that's the case for your particular `Stream` then this function will never return and will probably crash the VM with an `OutOfMemory` exception. This function will not hang on a finite cycle, however.

61. #### final def foreach[B](f: (A) ⇒ B): Unit

    Apply the given function `f` to each element of this linear sequence (while respecting the order of the elements).

    Apply the given function `f` to each element of this linear sequence (while respecting the order of the elements).

    f

      The treatment to apply to each element.

    Definition Classes
      Stream → LinearSeqOptimized → IterableLike → GenericTraversableTemplate → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic
    Annotations
      @tailrec()
    Note

      This function will force the realization of the entire stream unless the `f` throws an exception.

      ,

      Overridden here as final to trigger tail-call optimization, which replaces 'this' with 'tail' at each iteration. This is absolutely necessary for allowing the GC to collect the underlying stream as elements are consumed.

62. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Stream[A] to StringFormat[Stream[A]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

63. #### def genericBuilder[B]: Builder[B, Stream[B]]

    The generic builder that builds instances of Traversable at arbitrary element types.

    The generic builder that builds instances of Traversable at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

64. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

65. #### def groupBy[K](f: (A) ⇒ K): Map[K, Stream[A]]

    Partitions this traversable collection into a map of traversable collections according to some discriminator function.

    Partitions this traversable collection into a map of traversable collections according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new traversable collection.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to traversable collections such that the following invariant holds:

          (xs groupBy f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a traversable collection of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

66. #### def grouped(size: Int): Iterator[Stream[A]]

    Partitions elements in fixed size iterable collections.

    Partitions elements in fixed size iterable collections.

    size

      the number of elements per group

    returns

      An iterator producing iterable collections of size `size`, except the last will be less than size `size` if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `grouped`

67. #### def hasDefiniteSize: Boolean

    Tests whether this stream is known to have a finite size.

    Tests whether this stream is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      Stream → TraversableLike → TraversableOnce → GenTraversableOnce

68. #### def hashCode(): Int

    Hashcodes for `Seq` produce a value from the hashcodes of all the elements of the sequence.

    Hashcodes for `Seq` produce a value from the hashcodes of all the elements of the sequence.

    returns

      the hash code value for this object.

    Definition Classes
      LinearSeqLike → GenSeqLike → AnyRef → Any

69. #### def head: A

    Selects the first element of this iterable collection.

    Selects the first element of this iterable collection.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this iterable collection.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` if the iterable collection is empty.

70. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this traversable collection if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike → GenTraversableLike

71. #### def indexOf(elem: A, from: Int): Int

    [use case] Finds index of first occurrence of some value in this stream after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this stream after or at some start index.

    Note: may not terminate for infinite-sized collections.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this stream that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: A](elem: B, from: Int): Int

72. #### def indexOf(elem: A): Int

    [use case] Finds index of first occurrence of some value in this stream.

    [use case]

    Finds index of first occurrence of some value in this stream.

    Note: may not terminate for infinite-sized collections.

    elem

      the element value to search for.

    returns

      the index of the first element of this stream that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: A](elem: B): Int

73. #### def indexOfSlice[B >: A](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this sequence contains a given sequence as a slice.

    Finds first index after or at a start index where this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

74. #### def indexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds first index where this sequence contains a given sequence as a slice.

    Finds first index where this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      the first index such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

75. #### def indexWhere(p: (A) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      LinearSeqOptimized → SeqLike → GenSeqLike

76. #### def indexWhere(p: (A) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this general sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

77. #### def indices: Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this sequence.

    Definition Classes
      SeqLike

78. #### def init: Stream[A]

    The stream without its last element.

    The stream without its last element.

    returns

      A new `Stream` containing everything but the last element. If your `Stream` represents an infinite series, this method will not return.

    Definition Classes
      Stream → TraversableLike → GenTraversableLike
    Exceptions thrown

      `UnsupportedOperationException` if the stream is empty.

79. #### def inits: Iterator[Stream[A]]

    Iterates over the inits of this traversable collection.

    Iterates over the inits of this traversable collection. The first value will be this traversable collection and the final one will be an empty traversable collection, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this traversable collection

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

80. #### def intersect(that: collection.Seq[A]): Stream[A]

    [use case] Computes the multiset intersection between this stream and another sequence.

    [use case]

    Computes the multiset intersection between this stream and another sequence.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence of elements to intersect with.

    returns

      a new stream which contains all elements of this stream which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def intersect[B >: A](that: GenSeq[B]): Stream[A]

81. #### def isDefinedAt(x: Int): Boolean

    Tests whether this sequence contains given index.

    Tests whether this sequence contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    returns

      `true` if this sequence contains an element at position `idx`, `false` otherwise.

    Definition Classes
      LinearSeqOptimized → GenSeqLike

82. #### def isEmpty: Boolean

    Tests whether this sequence is empty.

    Tests whether this sequence is empty.

    returns

      `true` if the sequence contain no elements, `false` otherwise.

    Definition Classes
      SeqLike → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

83. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

84. #### final def isTraversableAgain: Boolean

    Tests whether this traversable collection can be repeatedly traversed.

    Tests whether this traversable collection can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      TraversableLike → GenTraversableLike → GenTraversableOnce

85. #### def iterator: Iterator[A]

    A lazier Iterator than LinearSeqLike's.

    A lazier Iterator than LinearSeqLike's.

    returns

      the new iterator

    Definition Classes
      Stream → LinearSeqLike → IterableLike → GenIterableLike

86. #### def last: A

    Selects the last element.

    Selects the last element.

    returns

      The last element of this sequence.

    Definition Classes
      LinearSeqOptimized → TraversableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` If the sequence is empty.

87. #### def lastIndexOf(elem: A, end: Int): Int

    [use case] Finds index of last occurrence of some value in this stream before or at a given end index.

    [use case]

    Finds index of last occurrence of some value in this stream before or at a given end index.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this stream that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def lastIndexOf[B >: A](elem: B, end: Int): Int

88. #### def lastIndexOf(elem: A): Int

    [use case] Finds index of last occurrence of some value in this stream.

    [use case]

    Finds index of last occurrence of some value in this stream.

    Note: will not terminate for infinite-sized collections.

    elem

      the element value to search for.

    returns

      the index of the last element of this stream that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def lastIndexOf[B >: A](elem: B): Int

89. #### def lastIndexOfSlice[B >: A](that: GenSeq[B], end: Int): Int

    Finds last index before or at a given end index where this sequence contains a given sequence as a slice.

    Finds last index before or at a given end index where this sequence contains a given sequence as a slice.

    that

      the sequence to test

    end

      the end index

    returns

      the last index `<= end` such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

90. #### def lastIndexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds last index where this sequence contains a given sequence as a slice.

    Finds last index where this sequence contains a given sequence as a slice.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      the last index such that the elements of this sequence starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

91. #### def lastIndexWhere(p: (A) ⇒ Boolean, end: Int): Int

    Finds index of last element satisfying some predicate before or at given end index.

    Finds index of last element satisfying some predicate before or at given end index.

    p

      the predicate used to test elements.

    returns

      the index `<= end` of the last element of this sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      LinearSeqOptimized → SeqLike → GenSeqLike

92. #### def lastIndexWhere(p: (A) ⇒ Boolean): Int

    Finds index of last element satisfying some predicate.

    Finds index of last element satisfying some predicate.

    Note: will not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the last element of this general sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

93. #### def lastOption: Option[A]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this traversable collection$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike → GenTraversableLike

94. #### def length: Int

    Returns the length of this `Stream`.

    Returns the length of this `Stream`.

    returns

      The length of this `Stream`.

    Definition Classes
      Stream → LinearSeqOptimized → SeqLike → GenSeqLike
    Note

      In order to compute the length of the `Stream`, it must first be fully realized, which could cause the complete evaluation of an infinite series, assuming that's what your `Stream` represents.

95. #### def lengthCompare(len: Int): Int

    Compares the length of this sequence to a test value.

    Compares the length of this sequence to a test value.

    len

      the test value that gets compared with the length.

    returns

      A value `x` where

          x <  0       if this.length <  len
          x == 0       if this.length == len
          x >  0       if this.length >  len

      The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

    Definition Classes
      LinearSeqOptimized → SeqLike

96. #### def lift: (Int) ⇒ Option[A]

    Turns this partial function into a plain function returning an `Option` result.

    Turns this partial function into a plain function returning an `Option` result.

    returns

      a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

    Definition Classes
      PartialFunction
    See also

      Function.unlift

97. #### final def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

    Returns the stream resulting from applying the given function `f` to each element of this stream.

    Returns the stream resulting from applying the given function `f` to each element of this stream. This returns a lazy `Stream` such that it does not need to be fully realized.

    B

      The element type of the returned collection That.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      `f(a0), ..., f(an)` if this sequence is `a0, ..., an`.

    Definition Classes
      Stream → TraversableLike → GenTraversableLike → FilterMonadic
    Example:

    1.     def naturalsFrom(i: Int): Stream[Int] = i #:: naturalsFrom(i + 1)
           naturalsFrom(1).map(_ + 10) take 5 mkString(", ")
           // produces: "11, 12, 13, 14, 15"

98. #### def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this stream.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def max[B >: A](implicit cmp: Ordering[B]): A

99. #### def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this stream with the largest value measured by function f.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

100. #### def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this stream

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def min[B >: A](implicit cmp: Ordering[B]): A

101. #### def minBy[B](f: (A) ⇒ B): A

     [use case] Finds the first element which yields the smallest value measured by function f.

     [use case]

     Finds the first element which yields the smallest value measured by function f.

     B

       The result type of the function f.

     f

       The measuring function.

     returns

       the first element of this stream with the smallest value measured by function f.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

102. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this stream in a string using start, end, and separator strings.

     Displays all elements of this stream in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this stream. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this stream are separated by the string `sep`.

     Definition Classes
       Stream → TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

103. #### def mkString: String

     Displays all elements of this stream in a string.

     Displays all elements of this stream in a string.

     returns

       a string representation of this stream. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this stream follow each other without any separator string.

     Definition Classes
       Stream → TraversableOnce → GenTraversableOnce

104. #### def mkString(sep: String): String

     Displays all elements of this stream in a string using a separator string.

     Displays all elements of this stream in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this stream. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this stream are separated by the string `sep`.

     Definition Classes
       Stream → TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

105. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

106. #### def newBuilder: Builder[A, Stream[A]]

     The builder that builds instances of type Traversable[A]

     The builder that builds instances of type Traversable[A]

     Attributes
       protected[this]
     Definition Classes
       GenericTraversableTemplate → HasNewBuilder

107. #### def nonEmpty: Boolean

     Tests whether the traversable or iterator is not empty.

     Tests whether the traversable or iterator is not empty.

     returns

       `true` if the traversable or iterator contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

108. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

109. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

110. #### def orElse[A1 <: Int, B1 >: A](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

111. #### def padTo[B >: A, That](len: Int, elem: B)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

     Returns a new sequence of given length containing the elements of this sequence followed by zero or more occurrences of given elements.

     Returns a new sequence of given length containing the elements of this sequence followed by zero or more occurrences of given elements.

     B

       The type of the value to pad with.

     That

       The type contained within the resulting `Stream`.

     len

       The number of elements to pad into the `Stream`.

     elem

       The value of the type `B` to use for padding.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       A new `Stream` representing the collection with values padding off to the end. If your `Stream` represents an infinite series, this method will not return.

     Definition Classes
       Stream → SeqLike → GenSeqLike
     Example:

     1.     def naturalsFrom(i: Int): Stream[Int] = i #:: { if (i < 5) naturalsFrom(i + 1) else Stream.Empty }
            naturalsFrom(1) padTo(10, 0) foreach println
            // prints
            // 1
            // 2
            // 3
            // 4
            // 5
            // 0
            // 0
            // 0
            // 0
            // 0

112. #### def par: ParSeq[A]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

113. #### def parCombiner: Combiner[A, ParSeq[A]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       Seq → SeqLike → Iterable → TraversableLike → Parallelizable

114. #### def partition(p: (A) ⇒ Boolean): (Stream[A], Stream[A])

     Returns all the elements of this stream that satisfy the predicate `p` returning of scala.Tuple2 of `Stream`s obeying the partition predicate `p`.

     Returns all the elements of this stream that satisfy the predicate `p` returning of scala.Tuple2 of `Stream`s obeying the partition predicate `p`. The order of the elements is preserved.

     p

       the predicate used to filter the stream.

     returns

       the elements of this stream satisfying `p`.

     Definition Classes
       Stream → TraversableLike → GenTraversableLike
     Example:

     1.     def naturalsFrom(i: Int): Stream[Int] = i #:: naturalsFrom(i + 1)
            val parts = naturalsFrom(1) partition { _ % 2 == 0 }
            parts._1 take 10 mkString ", "
            // produces: "2, 4, 6, 8, 10, 12, 14, 16, 18, 20"
            parts._2 take 10 mkString ", "
            // produces: "1, 3, 5, 7, 9, 11, 13, 15, 17, 19"

115. #### def patch(from: Int, that: GenSeq[A], replaced: Int): Stream[A]

     [use case] Produces a new stream where a slice of elements in this stream is replaced by another sequence.

     [use case]

     Produces a new stream where a slice of elements in this stream is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original stream

     returns

       a new stream consisting of all elements of this stream except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def patch[B >: A, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

116. #### def permutations: Iterator[Stream[A]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this sequence.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

117. #### def prefixLength(p: (A) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Note: may not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this general sequence such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

118. #### def print(sep: String): Unit

     Prints elements of this stream one by one, separated by `sep`.

     Prints elements of this stream one by one, separated by `sep`.

     sep

       The separator string printed between consecutive elements.

119. #### def print(): Unit

     Prints elements of this stream one by one, separated by commas.

120. #### def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements in this stream of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the stream and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def product[B >: A](implicit num: Numeric[B]): B

121. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this traversable or iterator using the specified associative binary operator.

     Reduces the elements of this traversable or iterator using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the traversable or iterator is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown

       `UnsupportedOperationException` if this traversable or iterator is empty.

122. #### final def reduceLeft[B >: A](f: (B, A) ⇒ B): B

     Stream specialization of reduceLeft which allows GC to collect along the way.

     Stream specialization of reduceLeft which allows GC to collect along the way.

     B

       The type of value being accumulated.

     f

       The operation to perform on successive elements of the `Stream`.

     returns

       The accumulated value from successive applications of `f`.

     Definition Classes
       Stream → LinearSeqOptimized → TraversableOnce

123. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

     Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this traversable or iterator is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

124. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

     Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

125. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

     Applies a binary operator to all elements of this sequence, going right to left.

     Applies a binary operator to all elements of this sequence, going right to left.

     Note: will not terminate for infinite-sized collections.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this sequence, going right to left:

           op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

       where `x1, ..., xn` are the elements of this sequence.

     Definition Classes
       LinearSeqOptimized → IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown

       `UnsupportedOperationException` if this sequence is empty.

126. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

     Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this traversable or iterator is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

127. #### def repr: Stream[A]

     The collection of type traversable collection underlying this `TraversableLike` object.

     The collection of type traversable collection underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

128. #### def reverse: Stream[A]

     A list consisting of all elements of this list in reverse order.

     A list consisting of all elements of this list in reverse order.

     returns

       A new `Stream` containing the representing of the original `Stream` in reverse order.

     Definition Classes
       Stream → SeqLike → GenSeqLike
     Example:

     1.     def naturalsFrom(i: Int): Stream[Int] = i #:: { if (i < 5) naturalsFrom(i + 1) else Stream.Empty }
            (naturalsFrom(1) reverse) foreach println
            // prints
            // 5
            // 4
            // 3
            // 2
            // 1

     Note

       This function must realize the entire `Stream` in order to perform this operation so if your `Stream` represents an infinite sequence then this function will never return.

129. #### def reverseIterator: Iterator[A]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: will not terminate for infinite-sized collections.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this sequence in reversed order

     Definition Classes
       SeqLike

130. #### def reverseMap[B](f: (A) ⇒ B): Stream[B]

     [use case] Builds a new collection by applying a function to all elements of this stream and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this stream and collecting the results in reversed order.

     Note: will not terminate for infinite-sized collections.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new stream resulting from applying the given function `f` to each element of this stream and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def reverseMap[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

131. #### def reversed: scala.List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

132. #### def runWith[U](action: (A) ⇒ U): (Int) ⇒ Boolean

     Composes this partial function with an action function which gets applied to results of this partial function.

     Composes this partial function with an action function which gets applied to results of this partial function. The action function is invoked only for its side effects; its result is ignored.

     Note that expression `pf.runWith(action)(x)` is equivalent to

         if(pf isDefinedAt x) { action(pf(x)); true } else false

     except that `runWith` is implemented via `applyOrElse` and thus potentially more efficient. Using `runWith` avoids double evaluation of pattern matchers and guards for partial function literals.

     action

       the action function

     returns

       a function which maps arguments `x` to `isDefinedAt(x)`. The resulting function runs `action(this(x))` where `this` is defined.

     Definition Classes
       PartialFunction
     Since

       2.10

     See also

       `applyOrElse`.

133. #### def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this stream.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this stream.

     Note: will not terminate for infinite-sized collections.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       LinearSeqOptimized → IterableLike → GenIterableLike
     Full Signature

     #### def sameElements[B >: A](that: GenIterable[B]): Boolean

134. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[Stream[A], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new traversable collection containing the prefix scan of the elements in this traversable collection

     Definition Classes
       TraversableLike → GenTraversableLike

135. #### final def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

     Create a new stream which contains all intermediate results of applying the operator to subsequent elements left to right.

     Create a new stream which contains all intermediate results of applying the operator to subsequent elements left to right. `scanLeft` is analogous to `foldLeft`.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       The initial value for the scan.

     op

       A function that will apply operations to successive values in the `Stream` against previous accumulated results.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       A new collection containing the modifications from the application of `op`.

     Definition Classes
       Stream → TraversableLike → GenTraversableLike
     Note

       This works because the target type of the scala.collection.mutable.Builder `That` is a `Stream`.

136. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

137. #### def segmentLength(p: (A) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     Note: may not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this sequence starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       LinearSeqOptimized → SeqLike → GenSeqLike

138. #### def seq: LinearSeq[A]

     A version of this collection with all of the operations implemented sequentially (i.e., in a single-threaded manner).

     A version of this collection with all of the operations implemented sequentially (i.e., in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       LinearSeq → LinearSeq → LinearSeqLike → Seq → Seq → GenSeq → GenSeqLike → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

139. #### def size: Int

     The size of this sequence, equivalent to `length`.

     The size of this sequence, equivalent to `length`.

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this sequence.

     Definition Classes
       SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

140. #### def slice(from: Int, until: Int): Stream[A]

     A substream starting at index `from` and extending up to (but not including) index `until`.

     A substream starting at index `from` and extending up to (but not including) index `until`. This returns a `Stream` that is lazily evaluated.

     from

       The index of the first element of the returned subsequence

     until

       The index of the element following the returned subsequence

     returns

       A new string containing the elements requested from `start` until `end`.

     Definition Classes
       Stream → LinearSeqOptimized → IterableLike → TraversableLike → GenTraversableLike
     Example:

     1.     naturalsFrom(0) slice(50, 60) mkString ", "
            // produces: "50, 51, 52, 53, 54, 55, 56, 57, 58, 59"

141. #### def sliding(size: Int, step: Int): Iterator[Stream[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     step

       the distance between the first elements of successive groups

     returns

       An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

142. #### def sliding(size: Int): Iterator[Stream[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.) "Sliding window" step is 1 by default.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.) "Sliding window" step is 1 by default.

     size

       the number of elements per group

     returns

       An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

143. #### def sortBy[B](f: (A) ⇒ B)(implicit ord: math.Ordering[B]): Stream[A]

     Sorts this `Seq` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this `Seq` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a sequence consisting of the elements of this sequence sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.     val words = "The quick brown fox jumped over the lazy dog".split(' ')
            // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
            words.sortBy(x => (x.length, x.head))
            res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

       Note: will not terminate for infinite-sized collections.

144. #### def sortWith(lt: (A, A) ⇒ Boolean): Stream[A]

     Sorts this sequence according to a comparison function.

     Sorts this sequence according to a comparison function.

     Note: will not terminate for infinite-sized collections.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a sequence consisting of the elements of this sequence sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.     List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
            List("Bob", "John", "Steve", "Tom")

145. #### def sorted[B >: A](implicit ord: math.Ordering[B]): Stream[A]

     Sorts this sequence according to an Ordering.

     Sorts this sequence according to an Ordering.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a sequence consisting of the elements of this sequence sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

146. #### def span(p: (A) ⇒ Boolean): (Stream[A], Stream[A])

     Splits this sequence into a prefix/suffix pair according to a predicate.

     Splits this sequence into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     returns

       a pair consisting of the longest prefix of this sequence whose elements all satisfy `p`, and the rest of this sequence.

     Definition Classes
       LinearSeqOptimized → TraversableLike → GenTraversableLike

147. #### def splitAt(n: Int): (Stream[A], Stream[A])

     Splits this stream into two at a given position.

     Splits this stream into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of streams consisting of the first `n` elements of this stream, and the other elements.

     Definition Classes
       Stream → TraversableLike → GenTraversableLike

148. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this sequence contains the given sequence at a given index.

     Tests whether this sequence contains the given sequence at a given index.

     Note: If the both the receiver object `this` and the argument `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this sequence at index `offset`, otherwise `false`.

     Definition Classes
       SeqLike → GenSeqLike

149. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this general sequence starts with the given sequence.

     Tests whether this general sequence starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

150. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation as `Stream`.

     Defines the prefix of this object's `toString` representation as `Stream`.

     returns

       a string representation which starts the result of `toString` applied to this stream. By default the string prefix is the simple name of the collection class stream.

     Definition Classes
       Stream → TraversableLike → GenTraversableLike

151. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this stream of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the stream and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def sum[B >: A](implicit num: Numeric[B]): B

152. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

153. #### def tail: Stream[A]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a traversable collection consisting of all elements of this traversable collection except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown

       ``UnsupportedOperationException`` if the traversable collection is empty.

154. #### def tails: Iterator[Stream[A]]

     Iterates over the tails of this traversable collection.

     Iterates over the tails of this traversable collection. The first value will be this traversable collection and the final one will be an empty traversable collection, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this traversable collection

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

155. #### def take(n: Int): Stream[A]

     Returns the `n` first elements of this `Stream` as another `Stream`, or else the whole `Stream`, if it has less than `n` elements.

     Returns the `n` first elements of this `Stream` as another `Stream`, or else the whole `Stream`, if it has less than `n` elements.

     The result of `take` is, again, a `Stream` meaning that it also does not make any needless evaluations of the `Stream` itself, delaying that until the usage of the resulting `Stream`.

     n

       the number of elements to take.

     returns

       the `n` first elements of this stream.

     Definition Classes
       Stream → LinearSeqOptimized → IterableLike → TraversableLike → GenTraversableLike
     Example:

     1.     def naturalsFrom(i: Int): Stream[Int] = i #:: naturalsFrom(i + 1)
            scala> naturalsFrom(5) take 5
            res1: scala.collection.immutable.Stream[Int] = Stream(5, ?)

            scala> naturalsFrom(5) take 5 mkString ", "
            // produces: "5, 6, 7, 8, 9"

156. #### def takeRight(n: Int): Stream[A]

     Returns the rightmost `n` elements from this iterable.

     Returns the rightmost `n` elements from this iterable.

     n

       the number of elements to take

     returns

       The last `n` elements from this `Stream`.

     Definition Classes
       Stream → IterableLike
     Note

       Take serious caution here. If the `Stream` represents an infinite series then this function will not return. The right most elements of an infinite series takes an infinite amount of time to produce.

157. #### def takeWhile(p: (A) ⇒ Boolean): Stream[A]

     Returns the longest prefix of this `Stream` whose elements satisfy the predicate `p`.

     Returns the longest prefix of this `Stream` whose elements satisfy the predicate `p`.

     p

       the test predicate.

     returns

       A new `Stream` representing the values that satisfy the predicate `p`.

     Definition Classes
       Stream → LinearSeqOptimized → IterableLike → TraversableLike → GenTraversableLike
     Example:

     1.        + naturalsFrom(0) takeWhile { _ < 5 } mkString ", "
            produces: "0, 1, 2, 3, 4"

158. #### def thisCollection: collection.LinearSeq[A]

     The underlying collection seen as an instance of ``Seq``.

     The underlying collection seen as an instance of ``Seq``. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       LinearSeqLike → SeqLike → IterableLike → TraversableLike

159. #### def to[Col[_]]: Col[A]

     [use case] Converts this stream into another by copying all elements.

     [use case]

     Converts this stream into another by copying all elements.

     Note: will not terminate for infinite-sized collections.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this stream.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, A, Col[A]]): Col[A]

160. #### def toArray: Array[A]

     [use case] Converts this stream to an array.

     [use case]

     Converts this stream to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this stream. An `ClassTag` must be available for the element type of this stream.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toArray[B >: A](implicit arg0: ClassTag[B]): Array[B]

161. #### def toBuffer[B >: A]: Buffer[B]

     Uses the contents of this traversable or iterator to create a new mutable buffer.

     Uses the contents of this traversable or iterator to create a new mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

162. #### def toCollection(repr: Stream[A]): collection.LinearSeq[A]

     A conversion from collections of type `Repr` to ``Seq`` objects.

     A conversion from collections of type `Repr` to ``Seq`` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       LinearSeqLike → SeqLike → IterableLike → TraversableLike

163. #### def toIndexedSeq: IndexedSeq[A]

     Converts this traversable or iterator to an indexed sequence.

     Converts this traversable or iterator to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

164. #### def toIterable: collection.Iterable[A]

     Returns this iterable collection as an iterable collection.

     Returns this iterable collection as an iterable collection.

     A new collection will not be built; lazy collections will stay lazy.

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

165. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this iterable collection.

     Returns an Iterator over the elements in this iterable collection. Produces the same result as `iterator`.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

166. #### def toList: scala.List[A]

     Converts this traversable or iterator to a list.

     Converts this traversable or iterator to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

167. #### def toMap[T, U]: collection.Map[T, U]

     [use case] Converts this stream to a map.

     [use case]

     Converts this stream to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this stream.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

168. #### def toParArray: ParArray[T]

     Implicit information
       This member is added by an implicit conversion from Stream[A] to CollectionsHaveToParArray[Stream[A], T] performed by method CollectionsHaveToParArray in scala.collection.parallel. This conversion will take place only if an implicit value of type (Stream[A]) ⇒ GenTraversableOnce[T] is in scope.
     Definition Classes
       CollectionsHaveToParArray

169. #### def toSeq: Seq[A]

     Converts this immutable sequence to a sequence.

     Converts this immutable sequence to a sequence.

     Note: will not terminate for infinite-sized collections.

     A new collection will not be built; in particular, lazy sequences will stay lazy.

     returns

       a sequence containing all elements of this immutable sequence.

     Definition Classes
       Seq → SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

170. #### def toSet[B >: A]: Set[B]

     Converts this traversable or iterator to a set.

     Converts this traversable or iterator to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

171. #### def toStream: Stream[A]

     Converts this stream to a stream.

     Converts this stream to a stream.

     returns

       a stream containing all elements of this stream.

     Definition Classes
       Stream → IterableLike → TraversableLike → GenTraversableOnce

172. #### def toString(): String

     Converts this stream to a string.

     Converts this stream to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this stream, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       Stream → SeqLike → Function1 → TraversableLike → AnyRef → Any

173. #### def toTraversable: collection.Traversable[A]

     Converts this traversable collection to an unspecified Traversable.

     Converts this traversable collection to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this traversable collection.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

174. #### def toVector: scala.Vector[A]

     Converts this traversable or iterator to a Vector.

     Converts this traversable or iterator to a Vector.

     Note: will not terminate for infinite-sized collections.

     returns

       a vector containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

175. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): Stream[Stream[B]]

     Transposes this collection of traversable collections into a collection of collections.

     Transposes this collection of traversable collections into a collection of collections.

     The resulting collection's type will be guided by the static type of collection. For example:

         val xs = List(
                    Set(1, 2, 3),
                    Set(4, 5, 6)).transpose
         // xs == List(
         //         List(1, 4),
         //         List(2, 5),
         //         List(3, 6))

         val ys = Vector(
                    List(1, 2, 3),
                    List(4, 5, 6)).transpose
         // ys == Vector(
         //         Vector(1, 4),
         //         Vector(2, 5),
         //         Vector(3, 6))

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this collection is a `Traversable`.

     returns

       a two-dimensional collection of collections which has as nth row the nth column of this collection.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown

       `IllegalArgumentException` if all collections in this collection are not of the same size.

176. #### def union(that: collection.Seq[A]): Stream[A]

     [use case] Produces a new sequence which contains all elements of this stream and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this stream and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     Note: will not terminate for infinite-sized collections.

     that

       the sequence to add.

     returns

       a new stream which contains all elements of this stream followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def union[B >: A, That](that: GenSeq[B])(implicit bf: CanBuildFrom[Stream[A], B, That]): That

177. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (Stream[A1], Stream[A2])

     Converts this collection of pairs into two collections of the first and second half of each pair.

     Converts this collection of pairs into two collections of the first and second half of each pair.

         val xs = Traversable(
                    (1, "one"),
                    (2, "two"),
                    (3, "three")).unzip
         // xs == (Traversable(1, 2, 3),
         //        Traversable(one, two, three))

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this collection is a pair.

     returns

       a pair of collections, containing the first, respectively second half of each element pair of this collection.

     Definition Classes
       GenericTraversableTemplate

178. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (Stream[A1], Stream[A2], Stream[A3])

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

         val xs = Traversable(
                    (1, "one", '1'),
                    (2, "two", '2'),
                    (3, "three", '3')).unzip3
         // xs == (Traversable(1, 2, 3),
         //        Traversable(one, two, three),
         //        Traversable(1, 2, 3))

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this collection is a triple.

     returns

       a triple of collections, containing the first, second, respectively third member of each element triple of this collection.

     Definition Classes
       GenericTraversableTemplate

179. #### def updated(index: Int, elem: A): Stream[A]

     [use case] A copy of this stream with one single replaced element.

     [use case]

     A copy of this stream with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a copy of this stream with the element at position `index` replaced by `elem`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def updated[B >: A, That](index: Int, elem: B)(implicit bf: CanBuildFrom[Stream[A], B, That]): That

180. #### def view: StreamView[A, Stream[A]]

     Creates a non-strict view of this stream.

     Creates a non-strict view of this stream.

     returns

       a non-strict view of this stream.

     Definition Classes
       Stream → SeqLike → IterableLike → TraversableLike

181. #### def view(from: Int, until: Int): SeqView[A, Stream[A]]

     Creates a non-strict view of a slice of this sequence.

     Creates a non-strict view of a slice of this sequence.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current sequence, whereas `slice` produces a new sequence.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this sequence, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

182. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

183. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

184. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

185. #### final def withFilter(p: (A) ⇒ Boolean): StreamWithFilter

     Creates a non-strict filter of this stream.

     Creates a non-strict filter of this stream.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this stream which satisfy the predicate `p`.

     Definition Classes
       Stream → TraversableLike → FilterMonadic

186. #### final def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[Stream[A], (A1, B), That]): That

     Returns a stream formed from this stream and the specified stream `that` by associating each element of the former with the element at the same position in the latter.

     Returns a stream formed from this stream and the specified stream `that` by associating each element of the former with the element at the same position in the latter.

     If one of the two streams is longer than the other, its remaining elements are ignored.

     The return type of this function may not be obvious. The lazy aspect of the returned value is different than that of `partition`. In `partition` we get back a scala.Tuple2 of two lazy `Stream`s whereas here we get back a single lazy `Stream` of scala.Tuple2s where the scala.Tuple2's type signature is `(A1, B)`.

     A1

       The type of the first parameter of the zipped tuple

     B

       The type of the second parameter of the zipped tuple

     That

       The type of the returned `Stream`.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       `Stream({a0,b0}, ..., {amin(m,n),bmin(m,n))}` when `Stream(a0, ..., am) zip Stream(b0, ..., bn)` is invoked.

     Definition Classes
       Stream → IterableLike → GenIterableLike
     Example:

     1.     def naturalsFrom(i: Int): Stream[Int] = i #:: naturalsFrom(i + 1)
            naturalsFrom(1) zip naturalsFrom(2) take 5 foreach println
            // prints
            // (1,2)
            // (2,3)
            // (3,4)
            // (4,5)
            // (5,6)

187. #### def zipAll[B](that: collection.Iterable[B], thisElem: A, thatElem: B): Stream[(A, B)]

     [use case] Returns a stream formed from this stream and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a stream formed from this stream and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this stream is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this stream.

     returns

       a new stream containing pairs consisting of corresponding elements of this stream and `that`. The length of the returned collection is the maximum of the lengths of this stream and `that`. If this stream is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this stream, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[Stream[A], (A1, B), That]): That

188. #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[Stream[A], (A1, Int), That]): That

     Zips this iterable with its indices.

     Zips this iterable with its indices. `s.zipWithIndex` is equivalent to `s zip s.indices`.

     This method is much like `zip` in that it returns a single lazy `Stream` of scala.Tuple2.

     A1

       The type of the first element of the scala.Tuple2 in the resulting stream.

     That

       The type of the resulting `Stream`.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, Int)`.

     returns

       `Stream({a0,0}, ..., {an,n)}`

     Definition Classes
       Stream → IterableLike → GenIterableLike
     Example:

     1.     def naturalsFrom(i: Int): Stream[Int] = i #:: naturalsFrom(i + 1)
            (naturalsFrom(1) zipWithIndex) take 5 foreach println
            // prints
            // (1,0)
            // (2,1)
            // (3,2)
            // (4,3)
            // (5,4)

189. #### def →[B](y: B): (Stream[A], B)

     Implicit information
       This member is added by an implicit conversion from Stream[A] to ArrowAssoc[Stream[A]] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1. #### def filter(p: (A) ⇒ Boolean): TraversableOnce[A]

   Implicit information
     This member is added by an implicit conversion from Stream[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stream: MonadOps[A]).filter(p)

   Definition Classes
     MonadOps

2. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from Stream[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stream: MonadOps[A]).flatMap(f)

   Definition Classes
     MonadOps

3. #### def map[B](f: (A) ⇒ B): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from Stream[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stream: MonadOps[A]).map(f)

   Definition Classes
     MonadOps

4. #### def withFilter(p: (A) ⇒ Boolean): Iterator[A]

   Implicit information
     This member is added by an implicit conversion from Stream[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stream: MonadOps[A]).withFilter(p)

   Definition Classes
     MonadOps

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from LinearSeqOptimized[A, Stream[A]]

### Inherited from LinearSeq[A]

### Inherited from collection.LinearSeq[A]

### Inherited from LinearSeqLike[A, Stream[A]]

### Inherited from Seq[A]

### Inherited from Iterable[A]

### Inherited from Traversable[A]

### Inherited from Immutable

### Inherited from AbstractSeq[A]

### Inherited from collection.Seq[A]

### Inherited from SeqLike[A, Stream[A]]

### Inherited from GenSeq[A]

### Inherited from GenSeqLike[A, Stream[A]]

### Inherited from PartialFunction[Int, A]

### Inherited from (Int) ⇒ A

### Inherited from AbstractIterable[A]

### Inherited from collection.Iterable[A]

### Inherited from IterableLike[A, Stream[A]]

### Inherited from Equals

### Inherited from GenIterable[A]

### Inherited from GenIterableLike[A, Stream[A]]

### Inherited from AbstractTraversable[A]

### Inherited from collection.Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, Stream]

### Inherited from TraversableLike[A, Stream[A]]

### Inherited from GenTraversableLike[A, Stream[A]]

### Inherited from Parallelizable[A, ParSeq[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, Stream[A]]

### Inherited from HasNewBuilder[A, scala.collection.immutable.Stream[A] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion CollectionsHaveToParArray from Stream[A] to CollectionsHaveToParArray[Stream[A], T]

### Inherited by implicit conversion MonadOps from Stream[A] to MonadOps[A]

### Inherited by implicit conversion any2stringadd from Stream[A] to any2stringadd[Stream[A]]

### Inherited by implicit conversion StringFormat from Stream[A] to StringFormat[Stream[A]]

### Inherited by implicit conversion Ensuring from Stream[A] to Ensuring[Stream[A]]

### Inherited by implicit conversion ArrowAssoc from Stream[A] to ArrowAssoc[Stream[A]]

### Inherited by implicit conversion alternateImplicit from Stream[A] to ForceImplicitAmbiguity

### Ungrouped